//
//	FUNCTION DECODER FOR LISP TYPE DES.
//

#ifndef _funcdec_h_
#define _funcdec_h_
#include "ulist.h"

#define SOF_SIG_POS 1
#define SOF_SIG_NEG 0

#define SOF_ATOM_NIL 0
#define SOF_ATOM_OPR 1
#define SOF_ATOM_VAL 2

class SOFRoot ;
class SOFNode ;
typedef ulist<SOFNode*> SOFList ;

class SOFRoot {
	public :
	int		 id ;
	int      sig_pole;
	char*    out_pin ;
	SOFNode* sof_root ;

	SOFRoot()
	{
		id = -1 ;
		out_pin = 0 ;
		sig_pole = SOF_SIG_POS ;
	}
	SOFRoot(int n, char* opn, int sp)
	{
		id = n ;
		out_pin = opn ;
		sig_pole = sp ;
	}
	~SOFRoot() {}

	inline SOFNode* get_sofnode_root() { return sof_root ; }
} ;

class SOFNode {
	public :
	int		atom_clas ;
	char*	atom_name ;
	int		sig_pole  ;
	SOFNode* parent ;
	SOFList  oprnd_list ;

	SOFNode()
	{
		atom_clas = SOF_ATOM_NIL ;
		atom_name = 0 ;
		sig_pole  = SOF_SIG_POS ;
		parent = 0 ;
	}
	SOFNode(int ac, char* an, int sp, SOFNode* pa)
	{
		atom_clas = ac ;
		atom_name = an ;
		sig_pole  = sp ;
		parent = pa ;
	}
	~SOFNode()
	{
		oprnd_list.clear() ;
	}

	inline SOFNode* append_operand(SOFNode* sn)
	{
		oprnd_list.append(sn) ;
		return sn ;
	}
} ;

#endif
