//
// GENERAL LIST CLASS
//
// Written and Revised by Akihiro Tsutsui (NTT Optical Network Systems Labs.)
// Copyright (c) 1994, 1995 Nippon Telegraph & Telephone Corporation

#include <glist.h>

void glist::clear()
{
	glink*	link_copy ;

	while (head) {
		link_copy = head ;
		lremove(head) ;
		delete link_copy ;
	}

	head = 0; tail = 0; current = 0; number = 0;
}

glink* glist::append(void* val)
{
	glink* link = new glink ;
	link->val = val ;

	if (tail) {
		tail->next = link ;
		link->prev = tail ;
	}
	else
		head = link ;

	tail = link ;

	number++ ;

	return link ;
}

void* glist::remove(glink* link)
{
	void*	tmp ;

	if (link == head)
		head = head->next ;
	if (link == tail)
		tail = tail->prev ;

	number-- ;
	tmp = link->val ;
	delete link ;

	return tmp ;
}
	
void* glist::getval()
{
	return current ? current->val : (void*)0 ;
}

glink* glist::succur()
{
	if (current)
		current = current->next ;
		
	return current ;
}

glink* glist::bakcur()
{
	if (current)
		current = current->prev ;

	return current ;
}

glist& glist::lappend(glink* link)
{
	if (tail) {
		tail->next = link ;
		link->prev = tail ;
	}
	else 
		head = link ;

	tail = link ;

	number++ ;
	return *this ;
}

glist& glist::lprepend(glink* link)
{
	if (head) {
		head->prev = link ;
		link->next = head ;
	}
	else
		tail = link ;

	head = link ;

	number++ ;
	return *this ;
}

glist& glist::lremove(glink* link)
{

	if (link == head)
		head = head->next ;
	if (link == tail)
		tail = tail->prev ;
	if (link->next)
		link->next->prev = link->prev ;
	if (link->prev)
		link->prev->next = link->next ;

	number-- ;
	return *this ;
}
