/*
  DATA TYPE DEFINITION FOR PCD FILE
  Written and Revised by Akihiro Tsutsui (NTT Optical Network Systems Labs.)
  Copyright (c) 1994, 1995 Nippon Telegraph & Telephone Corporation
*/

#ifndef _pcddef_h_
#define _pcddef_h_ 1

#include <string.h>
#include "ulist.h"

typedef enum {
	PIN_INPUT,
	PIN_OUTPUT,
	PIN_BIDIRECT,
	PIN_TRISTATE,
	PIN_UNUSED,
	PIN_UNDEF
} PCDPinType ;

class PCDPinInfo {
	public:
	int			id ;
	char		*name ;
	PCDPinType	type ;
	// constructor & destructor
	PCDPinInfo()
	{
		id = -1; name = 0; type = PIN_UNDEF;
	}
	PCDPinInfo(int n, const char* pn, PCDPinType pt)
	{
		id = n ;
		name = new char[strlen(pn)+1] ;
		strcpy(name, pn) ;
		type = pt ;
	}
	~PCDPinInfo()
	{
		delete name ;
	}
} ;

typedef ulist<PCDPinInfo*>	PCDPinList ;

struct PCD_MODULE {
	int			id ;
	char*		name ;
	PCDPinList*	pinlist ;
} ;

#endif
