//
//  GENERAL LIST CLASS
//
//  Written and Revised by Akihiro Tsutsui (NTT Optical Network Systems Labs.)
//  Copyright (c) 1994 Nippon Telegraph & Telephone Corporation

#ifndef _glist_h_
#define _glist_h_ 1

class glink {
	friend class glist ;
	protected :
	glink*	next ;
	glink*	prev ;
	void*	val  ;

	public :
	glink() {next = 0; prev = 0;}
	~glink()
	{
		if (prev) prev->next = next ;
		if (next) next->prev = prev ;
		next = 0 ; prev = 0 ;
	}
	void*		valis()  { return val ; }
	glink*		nextis() { return next; }
	glink*		previs() { return prev; }
};

class glist {
	protected :
	int			number ;
	glink*	head ;
	glink*	tail ;
	glink*	current ;

	public :
	glist() {head = 0; tail = 0; current = 0; number = 0;}
	~glist(){clear(); }

	void		clear() ;
	int	length() { return number ;}
	glink*	first() { return head ;}
	glink*	last()  { return tail ;}
	glink*	getcur() { return current; }
	glink*	succur() ;
	glink*	bakcur() ;
	glink*	append(void*) ;
	void*	remove(glink*) ;
	void*	getval() ;
	void*	get_first() { current = head; return getval(); }
	void*	get_last()  { current = tail; return getval(); }
	void	gohead() { current = head; }
	void	gotail() { current = tail; }
	glist&	lappend(glink*) ;
	glist&	lprepend(glink*) ;
	glist&	lremove(glink*) ;
};

#endif
